/// <reference types="react" />
import { PureComponent } from 'react';
import * as PropTypes from 'prop-types';
import { Theme } from './themes/themeBuilder';
export interface CodeProps {
    /** The code to be formatted */
    text: string;
    /** The language in which the code is written */
    language?: string;
    /** A custom theme to be applied, implements the Theme interface */
    theme?: Theme;
}
export default class Code extends PureComponent<CodeProps> {
    static propTypes: {
        text: PropTypes.Validator<any>;
        language: PropTypes.Requireable<any>;
        theme: PropTypes.Requireable<any>;
    };
    static defaultProps: {
        language: string;
        theme: {};
    };
    render(): JSX.Element;
}
