import * as tslib_1 from "tslib";
import * as React from 'react';
import { PureComponent } from 'react';
import * as PropTypes from 'prop-types';
import SyntaxHighlighter from 'react-syntax-highlighter';
import { normalizeLanguage, languageList } from './supportedLanguages';
import { applyTheme } from './themes/themeBuilder';
var Code = /** @class */ (function (_super) {
    tslib_1.__extends(Code, _super);
    function Code() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Code.prototype.render = function () {
        var language = this.props.language;
        var inlineCodeStyle = applyTheme(this.props.theme).inlineCodeStyle;
        var props = {
            language: normalizeLanguage(language),
            PreTag: 'span',
            style: inlineCodeStyle,
            showLineNumbers: false,
        };
        return React.createElement(SyntaxHighlighter, tslib_1.__assign({}, props), this.props.text);
    };
    Code.propTypes = {
        text: PropTypes.string.isRequired,
        language: PropTypes.oneOf(languageList),
        theme: PropTypes.object,
    };
    Code.defaultProps = {
        language: 'md',
        theme: {},
    };
    return Code;
}(PureComponent));
export default Code;
//# sourceMappingURL=Code.js.map