/// <reference types="react" />
import { PureComponent } from 'react';
import * as PropTypes from 'prop-types';
import { Theme } from './themes/themeBuilder';
export interface CodeBlockProps {
    /** The code to be formatted */
    text: string;
    /** The language in which the code is written */
    language?: string;
    /** Indicates whether or not to show line numbers */
    showLineNumbers?: boolean;
    /** A custom theme to be applied, implements the Theme interface */
    theme?: Theme;
}
export default class CodeBlock extends PureComponent<CodeBlockProps, {}> {
    static displayName: string;
    static propTypes: {
        text: PropTypes.Validator<any>;
        language: PropTypes.Requireable<any>;
        showLineNumbers: PropTypes.Requireable<any>;
        theme: PropTypes.Requireable<any>;
    };
    static defaultProps: {
        showLineNumbers: boolean;
        language: string;
        theme: {};
    };
    handleCopy(event: any): void;
    render(): JSX.Element;
}
