import * as tslib_1 from "tslib";
import * as React from 'react';
import { PureComponent } from 'react';
import * as PropTypes from 'prop-types';
import SyntaxHighlighter from 'react-syntax-highlighter';
import { normalizeLanguage, languageList } from './supportedLanguages';
import { applyTheme } from './themes/themeBuilder';
var CodeBlock = /** @class */ (function (_super) {
    tslib_1.__extends(CodeBlock, _super);
    function CodeBlock() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CodeBlock.prototype.handleCopy = function (event) {
        /**
         * We don't want to copy the markup after highlighting, but rather the preformatted text in the selection
         */
        var data = event.nativeEvent.clipboardData;
        if (data) {
            event.preventDefault();
            var selectedText = window.getSelection().toString();
            var document_1 = "<!doctype html><html><head></head><body><pre>" + selectedText + "</pre></body></html>";
            data.clearData();
            data.setData('text/html', document_1);
            data.setData('text/plain', selectedText);
        }
    };
    CodeBlock.prototype.render = function () {
        var language = this.props.language;
        var _a = applyTheme(this.props.theme), lineNumberContainerStyle = _a.lineNumberContainerStyle, codeBlockStyle = _a.codeBlockStyle, codeContainerStyle = _a.codeContainerStyle;
        var props = {
            language: normalizeLanguage(language),
            style: codeBlockStyle,
            showLineNumbers: this.props.showLineNumbers,
            PreTag: 'span',
            codeTagProps: { style: codeContainerStyle },
            lineNumberContainerStyle: lineNumberContainerStyle,
        };
        var codeText = this.props.text.toString();
        return (React.createElement(SyntaxHighlighter, tslib_1.__assign({}, props, { onCopy: this.handleCopy }), codeText));
    };
    CodeBlock.displayName = 'CodeBlock';
    CodeBlock.propTypes = {
        text: PropTypes.string.isRequired,
        language: PropTypes.oneOf(languageList),
        showLineNumbers: PropTypes.bool,
        theme: PropTypes.object,
    };
    CodeBlock.defaultProps = {
        showLineNumbers: true,
        language: 'md',
        theme: {},
    };
    return CodeBlock;
}(PureComponent));
export default CodeBlock;
//# sourceMappingURL=CodeBlock.js.map