"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("react");
var PropTypes = require("prop-types");
var react_syntax_highlighter_1 = require("react-syntax-highlighter");
var supportedLanguages_1 = require("./supportedLanguages");
var themeBuilder_1 = require("./themes/themeBuilder");
var Code = /** @class */ (function (_super) {
    tslib_1.__extends(Code, _super);
    function Code() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Code.prototype.render = function () {
        var language = this.props.language;
        var inlineCodeStyle = themeBuilder_1.applyTheme(this.props.theme).inlineCodeStyle;
        var props = {
            language: supportedLanguages_1.normalizeLanguage(language),
            PreTag: 'span',
            style: inlineCodeStyle,
            showLineNumbers: false,
        };
        return React.createElement(react_syntax_highlighter_1.default, tslib_1.__assign({}, props), this.props.text);
    };
    Code.propTypes = {
        text: PropTypes.string.isRequired,
        language: PropTypes.oneOf(supportedLanguages_1.languageList),
        theme: PropTypes.object,
    };
    Code.defaultProps = {
        language: 'md',
        theme: {},
    };
    return Code;
}(react_1.PureComponent));
exports.default = Code;
//# sourceMappingURL=Code.js.map